#######################################################################################
# This file is part of geniac.
# 
# Copyright Institut Curie 2020.
# 
# This software is a computer program whose purpose is to perform
# Automatic Configuration GENerator and Installer for nextflow pipeline.
# 
# You can use, modify and/ or redistribute the software under the terms
# of license (see the LICENSE file for more details).
# 
# The software is distributed in the hope that it will be useful,
# but "AS IS" WITHOUT ANY WARRANTY OF ANY KIND.
# Users are therefore encouraged to test the software's suitability as regards
# their requirements in conditions enabling the security of their systems and/or data.
# 
# The fact that you are presently reading this means that you have had knowledge
# of the license and that you accept its terms.
#######################################################################################



# check if config files are present in the conf/ folder
# of the git repository. If it is the case, they are compared
# with the files that are automatically generated by geniac
include("cmake/functionColorMessage.cmake")


message_color(INFO "src dir is: ${CMAKE_SOURCE_DIR}")

file(GLOB generated_config_files RELATIVE "${config_files_dir}" "${config_files_dir}/*.config" )

foreach(config_file ${generated_config_files})
    if(EXISTS ${config_files_in_git_dir}/${config_file})
      execute_process(COMMAND ${CMAKE_COMMAND} -E compare_files
        ${config_files_dir}/${config_file} ${config_files_in_git_dir}/${config_file} RESULT_VARIABLE is_identical)
      if(${is_identical} EQUAL 1)
        message_color(ERROR "${config_file}: is present in the source directory and not identical to the file generated by geniac")
        message(WARNING "file are different")
      else()
        message_color(STATUS "${config_file}: OK (the file is present in the source directory and identical to the file generated by geniac)")
      endif()
    else()
      message_color(STATUS "${config_file}: OK (generated by geniac)")
    endif()
endforeach()

