#######################################################################################
# This file is part of geniac.
# 
# Copyright Institut Curie 2020.
# 
# This software is a computer program whose purpose is to perform
# Automatic Configuration GENerator and Installer for nextflow pipeline.
# 
# You can use, modify and/ or redistribute the software under the terms
# of license (see the LICENSE file for more details).
# 
# The software is distributed in the hope that it will be useful,
# but "AS IS" WITHOUT ANY WARRANTY OF ANY KIND.
# Users are therefore encouraged to test the software's suitability as regards
# their requirements in conditions enabling the security of their systems and/or data.
# 
# The fact that you are presently reading this means that you have had knowledge
# of the license and that you accept its terms.
#######################################################################################


if(NOT WIN32)
  string(ASCII 27 Esc)
  set(ColourReset "${Esc}[m")
  set(ColourBold  "${Esc}[1m")
  set(Red         "${Esc}[31m")
  set(Green       "${Esc}[32m")
  set(Yellow      "${Esc}[33m")
  set(Blue        "${Esc}[34m")
  set(Magenta     "${Esc}[35m")
  set(Cyan        "${Esc}[36m")
  set(White       "${Esc}[37m")
  set(BoldRed     "${Esc}[1;31m")
  set(BoldGreen   "${Esc}[1;32m")
  set(BoldYellow  "${Esc}[1;33m")
  set(BoldBlue    "${Esc}[1;34m")
  set(BoldMagenta "${Esc}[1;35m")
  set(BoldCyan    "${Esc}[1;36m")
  set(BoldWhite   "${Esc}[1;37m")
endif()

function(message_color mode text)
    if(${mode} MATCHES WARNING)
        message(STATUS "${BoldMagenta} ${mode} - ${text} ${ColourReset}")
    elseif(${mode} MATCHES INFO)
        message(STATUS "${BoldBlue} ${mode} - ${text} ${ColourReset}")
    elseif(${mode} MATCHES OK)
        message(STATUS "${BoldGreen} ${mode} - ${text} ${ColourReset}")
    elseif(${mode} MATCHES ERROR)
        message(FATAL_ERROR "\n${BoldRed} ${mode} - ${text} ${ColourReset}")
    else()
        message(STATUS "${BoldYellow} ${mode} - ${text} ${ColourReset}")
    endif()
    
endfunction(message_color)
